/**
   This is Java 8 code.
*/
import java.util.function.IntFunction;

public class Closures
{
   public static IntFunction<Integer> incBy(int x)
   {
      IntFunction<Integer> inc = (y) ->
      {
         return x + y;
      };

      return inc;
   }

   public static void main(String[] args)
   {
      IntFunction<Integer> incBy5 = incBy(5);
      IntFunction<Integer> incBy6 = incBy(6);

      System.out.println( incBy5.apply(100) );
      System.out.println( incBy6.apply(100) );

      System.out.println( incBy5.apply(200) );
      System.out.println( incBy6.apply(200) );

      System.out.println( incBy(4).apply(5) );
      System.out.println( incBy(100).apply(200) );
   }
}
