{- in JavaScript

   function incBy(x)
   {
      function inc(y) // nested function
      {
         return x+y;  // non-local reference to x
      }
      
      return inc;     // return the nested function
   }

-}

incBy x = (\y -> x+y)

incBy5 = incBy 5       -- incby5 = \y -> 5+y

incBy100 = incBy 100  -- incbt100 = \y -> 100+y

{-

incBy5 4
incBy5 (-5)
incBy5 0

incBy100 3
incBy100 100

incBy 4 5

NOTE: In Haskell incBy is really (+) 
(+) = \x -> \y -> x+y
but that is NOT true in JavaScript because 
JavaScript does not curry functions.

-}

{-
A programming language must have closures if 
the language has the following four features.

   1) Lexical scope
   2) Non-local references
   3) Function return values
   4) Nested functions
   
The C language has 1-3 but not 4.
-}
